// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic', 'starter.controllers'])

.run(function($ionicPlatform, $rootScope, $state, $http, $ionicHistory, $ionicPopup, $timeout, $sce, constants) {


  $rootScope.app = APP_CONFIGURATION;

  // Transform some tags to HTML in about
  $rootScope.app.about = $sce.trustAsHtml(APP_CONFIGURATION.about.replace(/\n/i,'<br>'));

  $rootScope.app.social_bar = [];
  $rootScope.app.footer_bar = [];

  for(var i in APP_CONFIGURATION.socials) {
    var social = APP_CONFIGURATION.socials[i];

    switch(social.id) {
      case 'facebook':
        $rootScope.app.social_bar.push({
          icon: 'fa-facebook',
          click: function(){

            if (typeof startApp === "undefined") {
              window.open('https://www.facebook.com/' + social.remote_id);
            }
            else {
              if (device.platform.toLowerCase() == 'ios') {
                startApp.set("fb://profile/" + social.remote_id ).start(function(){
                  //alert('success');
                }, function(error) {
                  window.open('https://www.facebook.com/' + social.remote_id);
                });             
              }
              else if (device.platform.toLowerCase() == 'android') {
                startApp.set({ /* params */
                "action": "ACTION_VIEW",
                "uri": "fb://facewebmodal/f?href=https://www.facebook.com/"+social.remote_url
              }).start(function(){
                  //alert('success');
                }, function(error) {
                  window.open('https://www.facebook.com/' + social.remote_id);
                });
              }
            }
          }
        });
      break;
    }
  }

  if (typeof APP_CONFIGURATION.coordinates !== "undefined") {
    $rootScope.app.footer_bar.push({
      title: '<i class="fa fa-2x fa-map-marker"></i>',
      click: function() {
        if (typeof launchnavigator !== "undefined") {
          launchnavigator.navigate(APP_CONFIGURATION.coordinates);
        }
        else {
          window.open('http://www.google.com/maps/place/' + APP_CONFIGURATION.coordinates.toString() , '_blank');
        }
      }
    });
  }

  if (typeof APP_CONFIGURATION.website !== "undefined") {
    $rootScope.app.footer_bar.push({
      title: '<i class="fa fa-2x fa-globe"></i>',
      click: function() {
        window.open(APP_CONFIGURATION.website, '_blank');
      }
    });
  }

  if (typeof APP_CONFIGURATION.socials.facebook !== "undefined") {
  
      $rootScope.app.footer_bar.push({
        title: '<i class="fa fa-2x fa-comment"></i>',
        click: function() {

          if (typeof startApp === "undefined") {
            window.open('https://www.facebook.com/messages/' + APP_CONFIGURATION.socials.facebook.remote_id, '_blank');
            return;
          }

          if (device.platform.toLowerCase() == 'ios') {
            //window.open('fb://messaging?id=141536459330730');
            startApp.set("fb://messaging?id=" + APP_CONFIGURATION.socials.facebook.remote_id).start(function(){
              //alert('success');
            }, function(error) {
              window.open('https://www.facebook.com/messages/' + APP_CONFIGURATION.socials.facebook.remote_id, '_blank');
            });
          }           
          else if (device.platform.toLowerCase() == 'android') {
            startApp.set({ /* params */
            "action": "ACTION_VIEW",
            "uri": "fb://messaging/compose/" + APP_CONFIGURATION.socials.facebook.remote_id
        }).start(function(){
              //alert('success');
            }, function(error) {
              window.open('https://www.facebook.com/messages/' + APP_CONFIGURATION.socials.facebook.remote_id, '_blank');
            });
          }          
        }
      });
  }

  $rootScope.$state = $state;
  $ionicPlatform.ready(function() {    
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      cordova.plugins.Keyboard.disableScroll(true);

    }
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
    }


    /*
    if (window.analytics) {
      if (ionic.Platform.isIPad()) {
        $rootScope.currentPlatform = 'ipad';
        window.analytics.startTrackerWithId('UA-78797095-1');
      }
      else if (ionic.Platform.isIOS()) {
        $rootScope.currentPlatform = 'iphone';
        window.analytics.startTrackerWithId('UA-78797095-1');
      }
      else if (ionic.Platform.isAndroid()) {
        $rootScope.currentPlatform = 'android';
        window.analytics.startTrackerWithId('UA-78797095-2');
      }
      window.analytics.setUserId(device.uuid);
    }
    */

    if (typeof device === 'undefined') {
      device = {
        uuid: 'test-uuid',
        platform: 'ios',
        model: 'test-model',
        version: 'test-version'
      };
    }

    $http.post(constants.API_URL+'/setdevice',{
      uuid: device.uuid,
      platform: device.platform,
      model: device.model,
      version: device.version,
      app_id: constants.APP_ID
    });
  
    console.log('device uuid '+device.uuid);
    $rootScope.device = device;
    $rootScope.push_token = 'none';

    if (typeof PushNotification !== 'undefined') {
      console.log('pushnotification');
      var push = PushNotification.init({ "android": {"senderID": constants.ANDROID_SENDER_ID},
         "ios": {"alert": true, "badge": true, "clearBadge" : true, "sound": true}, "windows": {} } );
      $rootScope.push_token = '??';

      push.on('registration', function(data) {
          //alert('registration '+JSON.stringify(data));
          // data.registrationId
          $http.post(constants.API_URL+'/setdevice',{
            uuid: device.uuid,
            push_token: data.registrationId,
            platform: device.platform,
            model: device.model,
            version: device.version,
            app_id: constants.APP_ID
          });
          $rootScope.push_token = data.registrationId;
      });

      push.on('notification', function(data) {
        console.log('on notification');
        if (typeof data.additionalData.custom !== 'undefined') {

          if (data.additionalData.foreground) {
            $ionicPopup.alert({
             title: 'Attenzione',
             template: data.message
           });            
          }
          
          $ionicHistory.nextViewOptions({
           historyRoot: true,
           disableAnimate: true,
           expire: 300
          });
          $timeout(function(){
            $state.go('app.categorytab',{ id: data.additionalData.custom.category_id }, {reload:true});
          });          
        }
        $rootScope.notification = JSON.stringify(data);                  
      });

      push.on('error', function(e) {
          // e.message
          //alert('Push register error' + e.message);
      });
    }    

    $rootScope.$on('$stateChangeStart', 
    function(event, toState, toParams, fromState, fromParams){ 
        //console.log(toState);
        if (window.analytics) {
          window.analytics.trackView(toState.name);
        }
        //event.preventDefault(); 
        // transitionTo() promise will be rejected with 
        // a 'transition prevented' error
    });

  });  
})

.config(function($stateProvider, $urlRouterProvider) {
  $stateProvider

    .state('app', {
    url: '/app',
    abstract: true,
    templateUrl: 'templates/menu.html',
    controller: 'AppCtrl'
  })

    .state('app.home', {
      url: '/home',
      views: {
        'menuContent': {
          templateUrl: 'templates/home.html',
          controller: 'HomeCtrl'
        }
      },
      data: {
        class: 'home'
      }
    })
    .state('app.fidelity', {
      url: '/fidelity',
      views: {
        'menuContent': {
          templateUrl: 'templates/fidelity.html',
          controller: 'FidelityCtrl'
        }
      },
      data: {
        class: 'category'
      }
    })
    .state('app.category', {
      url: '/category/:id',
      abstract: true,
      views: {
        'menuContent': {
          templateUrl: 'templates/category.html',
          controller: 'CategoryCtrl'
        }
      },
      data: {
        class: 'category'
      }
    })
    .state('app.categorytab', {
      url: '/category/:id/:tab',
      params: {reload: true},
      views: {
        'menuContent': {
          templateUrl: 'templates/category.html',
          controller: 'CategoryCtrl'
        }
      },
      data: {
        class: 'category'
      }
    })

    ;
  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/app/home');
})
.constant('constants', {
  //API_URL: '/api',  
  API_URL: typeof cordova === 'undefined' ? '/api' : 'https://myapp.taumob.com/api',
  APP_ID: APP_CONFIGURATION.id,
  ANDROID_SENDER_ID: '16022969621',
})
;
