angular.module('starter.controllers', [])

.controller('AppCtrl', function($scope, $ionicModal, $timeout) {

  // With the new view caching in Ionic, Controllers are only called
  // when they are recreated or on app start, instead of every page change.
  // To listen for when this page is active (for example, to refresh data),
  // listen for the $ionicView.enter event:
  //$scope.$on('$ionicView.enter', function(e) {
  //});

})

.controller('HomeCtrl', function($scope, $rootScope, $stateParams, $state, $http, $ionicHistory, $ionicPlatform, $ionicPopup, constants) {  
  $scope.messages = [];
  $rootScope.user = {
    points: -1
  };
  $scope.user = $rootScope.user;

  $ionicPlatform.ready(function() {  

    if (typeof navigator.connection !== "undefined" && typeof Connection !== "undefined") {
      var networkState = navigator.connection.type;
      if (networkState === Connection.NONE) {
        var alertPopup = $ionicPopup.alert({
         title: 'Nessuna connessione internet',
         template: 'Attenzione, questa applicazione necessita di una connessione internet per visualizzare informazioni aggiornate.'
       });
      }  
    }

    $http.get(constants.API_URL+'/messages?unread=1&app_id='+constants.APP_ID+'&uuid='+device.uuid)
      .then(function(data){
        if (data.status==200) {
          $scope.messages = data.data.messages;
        }
    });  

    $http.get(constants.API_URL+'/user?&app_id='+constants.APP_ID+'&uuid='+device.uuid)
      .then(function(data){
        if (data.status==200) {
          $rootScope.user = data.data;
          $scope.user = $rootScope.user;
        }
    });  
  });

  $scope.openEmail = function(email) {
    window.open('mailto:'+email, '_system');
  };

    $scope.openMessage = function(message) {
      $ionicHistory.nextViewOptions({
       historyRoot: true,
       disableAnimate: true,
       expire: 300
      });
      //$ionicSideMenuDelegate.toggleLeft();      
      $state.go('app.categorytab',{id:message.category_id},{reload:true});
    };

    $scope.callNumber = function(number) {
      if (typeof window.plugins !== "undefined") {
        window.plugins.CallNumber.callNumber(function(){}, function(){}, number);
      }      
      else {
        alert('Calling number '+number);
      }
    };
})

.controller('MenuCtrl', function($scope, $rootScope, $ionicSideMenuDelegate, $state, $ionicHistory, $http, $ionicModal, constants) {
  console.log('MenuCtrl');
  $scope.menu_items = [];
  $scope.settings = {
    category_selected : [],
    full_name : '',
    sex: '',
    birthday: '',
    tel: '',
    email: ''
  };

  $http.get(constants.API_URL+'/menu?app_id='+constants.APP_ID)
    .then(function(data){
      console.log(data);
      if (data.status==200) {
        $scope.menu_items = data.data;      

        // If the user is new, ask for interests, only in live version, not in emulator:
        
        if (window.cordova) {
          var applaunchCount = window.localStorage.getItem('launchCount');
          //Check if it already exists or not
          if(applaunchCount){
             //This is a second time launch, and count = applaunchCount
          }else{
            //Local storage is not set, hence first time launch. set the local storage item
            window.localStorage.setItem('launchCount',1);
            $scope.openSettings();

            //Do the other stuff related to first time launch
          }     
        }           
      }
  });

  $scope.goToCategory = function(item) {
    if (item.is_link === true) {
      $ionicHistory.nextViewOptions({
       historyRoot: true,
       disableAnimate: true,
       expire: 300
      });
      $ionicSideMenuDelegate.toggleLeft();      
      $state.go('app.categorytab',{id:item.id},{reload:true});
    }
    else {
      item.show = !item.show;
    }
  };

  $scope.isGroupShown = function(group) {
    return group.show;
  };

  $scope.closeSettings = function() {
    $scope.modal.hide();
  };

  $scope.saveSettings = function() {

    if ($scope.settings.birthday !== '') {
      var date = new Date($scope.settings.birthday);
      console.log(date);
    }
    $http.post(constants.API_URL+'/save_settings',{
      settings : $scope.settings,
      uuid: device.uuid,
      app_id: constants.APP_ID
    })
    .then(function(){
      $scope.modal.hide();
    });    
  };

  $scope.categoryClick = function(cat) {
    var i;
    if (cat.active && cat.parent_id !== null) {
      for(i in $scope.settings.category_selected) {
        if ($scope.settings.category_selected[i].id == cat.parent_id)
          $scope.settings.category_selected[i].active = true;
      }
    }
    if (cat.parent_id === null) {
      for(i in $scope.settings.category_selected) {
        if ($scope.settings.category_selected[i].parent_id == cat.id)
          $scope.settings.category_selected[i].active = cat.active;
      }
    }
    
  };

  $rootScope.openSettings = function() {

    $http.get(constants.API_URL+'/get_settings?app_id='+constants.APP_ID+'&uuid='+device.uuid)
    .then(function(data){
      if (data.status==200) {
        $scope.settings = data.data;
        $scope.settings.birthday = new Date($scope.settings.birthday);

        $ionicModal.fromTemplateUrl('settings.html', {
          scope: $scope,
          animation: 'slide-in-up'
        }).then(function(modal) {
          $scope.modal = modal;
          $scope.modal.show();
        });

      }
    });    
  };
})

.controller('CategoryCtrl', function($scope, $state, $stateParams, $http, $ionicTabsDelegate, constants, $timeout, $sce) {

  console.log('CategoryCtrl');

  $scope.$on('$ionicView.beforeEnter', function(){
    // Any thing you can think of
    console.log('before enter category');
    init();
  });

  $scope.category = {};
  $scope.tab = {};
  $scope.tabs = [];

  function init() {    
    $http.get(constants.API_URL+'/category/?app_id='+constants.APP_ID+'&id='+$stateParams.id)
    .then(function(data){
      if (data.status==200) {
        $scope.category = data.data;
      }
    });
    $http.get(constants.API_URL+'/tabs/?app_id='+constants.APP_ID+'&category_id='+$stateParams.id)
    .then(function(data){
      if (data.status==200) {
        $scope.tabs = data.data.tabs;
        $timeout(function(){
          $ionicTabsDelegate.select(0);
        });
      }
    });
  }

  $scope.onTabSelected = function(id) {
      $http.get(constants.API_URL+'/tab?app_id='+constants.APP_ID+'&id='+id)
      .then(function(data){
        if (data.status==200) {
          $scope.tab = data.data;

          var content = data.data.content;

          if (!window.cordova) {
            // PREPARE GOOGLE MAPS 
            if (typeof APP_CONFIGURATION.coordinates !== "undefined") {
              content = content.replace(/LATITUDE/g,APP_CONFIGURATION.coordinates[0]).replace(/LONGITUDE/g,APP_CONFIGURATION.coordinates[1]);
            }
            else { // 44.540, lng: -78.546
              content = content.replace(/LATITUDE/g,44.540).replace(/LONGITUDE/g,-78.546);
            }

            if (typeof APP_CONFIGURATION.phone !== "undefined") {
              content = content.replace(/#TEL#/g,APP_CONFIGURATION.phone);
            }

            if (typeof APP_CONFIGURATION.address !== "undefined") {
              content = content.replace(/#ADDRESS#/g,APP_CONFIGURATION.address.replace(/\n/g,"<br>") );
            }

            content = content.replace(/#NAME#/,APP_CONFIGURATION.title);
          }

          $scope.tab.content = $sce.trustAsHtml(content);
        }
      });
    };

  ///init();
})
.controller('FidelityCtrl', function($scope, $rootScope, $ionicTabsDelegate, $stateParams, $state, $http, $ionicHistory, $ionicPlatform, $ionicPopup, constants, $ionicLoading) {  
  $scope.user = $rootScope.user;

  $scope.addPoints = function() {
    $ionicLoading.show();
    console.log('adding points...');


    if (typeof cordova === "undefined") {
      // Simulate code insertion
      var json = {"points":10,"hash":"792357B17A8BAAE6D0C118E33B10D76C"};
      processPoints(json);
      
    }
    else {          
         cordova.plugins.barcodeScanner.scan(
            function (result) {
              if (!result.cancelled && result.format.toLowerCase()=='qr_code') {

                  var json = JSON.parse(result.text);
                  processPoints(json);
                  /*
                  var url = result.text;
                  var dummy = url.substr(url.indexOf('?')+1);
                  var key = dummy.substr(dummy.indexOf('=')+1);
                  key = key.substr(0,key.indexOf('&'));
                  var secret = dummy.substr(dummy.indexOf('&')+1);
                  secret = secret.substr(secret.indexOf('=')+1);                                        
                  $scope.settings.api_key = key;
                  $scope.settings.api_secret = secret;
                  $scope.$apply();
                  */
              }
              else {
                $ionicLoading.hide();
                $ionicTabsDelegate.select(0);
              }          
            }, 
            function (error) {
              $ionicPopup.alert({
                  title: 'Scanning failed',
                  template: error
              });
              $ionicLoading.hide();
            }
          );
    }

 
  };

  function processPoints(j) {
    $http.post(constants.API_URL+'/add_points',{
      uuid: device.uuid,
      app_id: constants.APP_ID,
      points: j.points,
      hash: j.hash
    })
    .then(function(data){
      $ionicLoading.hide();
      $ionicTabsDelegate.select(0);
      if (data.status==200) {
        $rootScope.user.points = data.data.points;   

        console.log(data.data);
        if (data.data.prizes.length > 0) {

          text = '';
          for(var i in data.data.prizes) {
            text += data.data.prizes[i].name+"<br>";
          }

          $ionicPopup.alert({
              title: 'Puoi richiedere questi premi!',
              template: text
          });
        }

        $scope.$apply();     
      }      
    }, function(){
      $ionicLoading.hide();
      $ionicTabsDelegate.select(0);
    });
  }
})
;
